# -*- coding: utf-8 -*-
"""
Created on Tue Jun 25 14:13:02 2019

@author: marce
"""

import json
import pandas as pd
import numpy as np

#Lesson: pandas read_csv uses as a default pythons native utf-8 encoding, in contrary open uses windows native latin-1! #Fuck
#Used to unpack json into ne big csv

#Loads vincenzos data
tweets = []
for line in open('yearsdata_kanton_27.json', encoding='utf-8'):
    tweets.append(json.loads(line))
#Loads the csv source and renames accordingly as well as round to the same number of digits.
data_wide=pd.read_csv('example_wide.csv', encoding='latin-1')
data_wide.rename(columns={'GDENR': 'genid', 'GDENAME': 'gdname', 'period': 'date'}, inplace=True)
data_wide.iloc[: , 3:53]=np.round(data_wide.iloc[: , 3:53], decimals=4)
#Missing values are filled from previous/nxt values within gmde so one has to iterate over gmde
gde_list=data_wide.genid.unique()
#For future his anzahl values are int mine are float.
output=pd.DataFrame()
for i in range(0, len(gde_list)):
    ds1=data_wide[(data_wide['genid']==gde_list[i])]    
    ds1_num=ds1.iloc[: , 3:53]#Gets only numerical columns to fill 
    ds2=ds1_num.fillna(method='ffill')#Fills nan forward from previous values (doesnt work if first value is missing)
    ds2=ds2.fillna(method='bfill')#Fills towards back if the first value was missing
    ds1_num.fillna(1000000, inplace=True)#In the original dataset replaces all nans by 100000 to target them
    ds1_stack=ds1_num.stack()#Reshapes both dataframes into the series indexed by labels for each value in order to target values
    ds2_stack=ds2.stack()
    ds1_stack[ ds1_stack != 1000000] = ds1_stack.astype(str).apply(lambda x: [x, 1])#Now targets previous nans, where they werent one creates a list with 1 indicator for the original values
    ds1_stack[ ds1_stack == 1000000] = ds2_stack.astype(str).apply(lambda x: [x, 0])#Where were nans before one uses the fillna values with 0 indicator
    ds1_num=ds1_stack.unstack()#Unstack the result
    ds1.iloc[: , 3:53]=ds1_num#Replace the newly done columns in the old dataset
    output=output.append(ds1)
    print(i)
output.to_csv('output_ready.csv')#Sames intermediate output
output['date']=output['date'].astype(str)#These two are strings in his output
output['genid']=output['genid'].astype(str)
test_json=output.to_json(orient='records')#Test the output into the json strin
with open('data.json', 'w', encoding='utf-8') as f:#Save the output into properly encoded file
    f.write(output.to_json(orient='records', force_ascii=False))
#This ensures its written with correct encoding

for line in open('data.json', encoding='utf-8'):#Open the saved file to check if parsed correctly
    tweets.append(json.loads(line))

#Now doing the shapefile
import geopandas as gpd
from geopandas.geoseries import *
shapes_vinc=gpd.GeoDataFrame.from_file("kanton_28.geojson")
shape_cut_lakes=gpd.GeoDataFrame.from_file("gmd_shapefile_lakes_cut.shp")
shape_cut_lakes.columns
shapes_vinc.columns
output_data=shapes_vinc[['genid', 'gdname', 'period', 'Alter: Anteil 0-19 Jahre',
       'Alter: Anteil 20-39 Jahre', 'Alter: Anteil 40-64 Jahre',
       'Alter: Anteil 65+ Jahre', 'Anteil Ausländer',
       'Anteil Beschäftigung Sektor 1', 'Anteil Beschäftigung Sektor 2',
       'Anteil Beschäftigung Sektor 3', 'Anteil Haushalte: 1 Person',
       'Anteil Haushalte: 2 Personen', 'Anteil Haushalte: 3 Personen',
       'Anteil Haushalte: 4 Personen', 'Anteil Haushalte: 5 Personen',
       'Anteil Haushalte: 6+ Personen', 'Anteil mit GA', 'Anteil mit Halbtax',
       'Anzahl Haushalte', 'Anzahl neue Wohnungen über 5 Jahre',
       'Beschäftigung', 'Bevölkerungsveränderung Saldo',
       'Durch. Anzahl Stimmbürger', 'Durchschnittliche Haushaltsgrosse',
       'Durchschnittliches Reineinkommen pro Steuerpflichtiger',
       'Leerstand Anzahl', 'Leerstand in %', 'Neue Wohnungen Anzahl',
       'Ständige Wohnbevölkerung',
       'Turnover: (Zuzüge + Wegzüge) / Bevölkerung',
       'Veränderung Anzahl Wohnungen über 5 Jahre',
       'Wahlbeteiligung Abstimmungen', 'Wahlbeteiligung NR',
       'Wähleranteil NR: BDP', 'Wähleranteil NR: CVP', 'Wähleranteil NR: FDP',
       'Wähleranteil NR: GLP', 'Wähleranteil NR: GPS', 'Wähleranteil NR: SP',
       'Wähleranteil NR: SVP', 'Wähleranteil NR: Übrige', 'Wegzug Total',
       'Wegzug Total in % der Bevölkerung', 'Wohnungsbestand Anzahl',
       'Zivilstand Anteil: Andere', 'Zivilstand Anteil: Geschieden',
       'Zivilstand Anteil: Ledig', 'Zivilstand Anteil: Verheiratet',
       'Zivilstand Anteil: Verwitwet', 'Zuzug Total',
       'Zuzug Total  in % der Bevölkerung']]
output_data.drop_duplicates(inplace=True)
output_data.dtypes
output_shape=shape_cut_lakes[['BFS_NUMMER', 'geometry']]
output_shape.columns=['genid', 'geometry']
output_shape.dtypes
output=output_data.merge(output_shape, how='right', on='genid')
output=gpd.GeoDataFrame(output)
output.to_file('shapefile_updated.geojson', driver='GeoJSON', encoding='utf-8')




